/*
NAME:       cliente
SYNOPSIS:    cliente hostid portnumber 
*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <strings.h>
#include <string.h>
#include <stdlib.h>

#define MAXHOSTNAME 80
#define BUFSIZE 1024
char buf[BUFSIZE];
char rbuf[BUFSIZE];
  char plato[6];
  char bebida[8];
  char postre[8];
  char mesa[4]="1que";
  char pedido[6]="pedido";
  char mesero[6]="mesero";
  char llamar[6]="llamar";
    int   sd;


//// Funcion que selecciona el plato que se desea y lo envia al servidor//////
void enviar_plato(){
int condicion=0;
  printf("1)menu 1\t2)menu 2\t");
  scanf("%d",&condicion);
  if(condicion==1){
   strcpy(plato,"menu 1");
       }
  if(condicion==2){
   strcpy(plato,"menu 2");
    }
  send(sd, plato, 6, 0);
}

//// Funcion que selecciona la bebida que se desea y la envia al servidor//////

void enviar_bebida(){
int condicion=0;
  printf("1)bebida 1\t2)bebida 2\t");
  scanf("%d",&condicion);
  if(condicion==1){
   strcpy(bebida,"bebida 1");
       }
  if(condicion==2){
   strcpy(bebida,"bebida 2");
    }
  send(sd, bebida, 8, 0);
}


//// Funcion que selecciona el postre que se desea y lo envia al servidor//////
void enviar_postre(){
int condicion=0;
  printf("1)postre 1\t2)postre 2\t");
  scanf("%d",&condicion);
  if(condicion==1){
   strcpy(postre,"postre 1");
       }
  if(condicion==2){
   strcpy(postre,"postre 2");
    }
  send(sd, postre, 8, 0);
}

// funcion que envia al servidor la orden indicando que se enviara un pedido///
void enviar_pedido(){
  send(sd, pedido, 6, 0);
  recv(sd, rbuf, sizeof(rbuf), 0);
}

//// Funcion que envia la orden al servidor para que llame al mozo//////
void enviar_llamar(){
  send(sd, llamar, 6, 0);
  recv(sd, rbuf, sizeof(rbuf), 0);
}

// funcion que envia el ID de la mesa///
void enviar_mesa(){
  send(sd, mesa, 1, 0);
  recv(sd, rbuf, sizeof(rbuf), 0);
}

main( argc, argv )
int argc;
char *argv[];
{

  struct   sockaddr_in server;
  struct  hostent *hp, *gethostbyname();
  struct  servent *sp;
  struct sockaddr_in from;
  struct sockaddr_in addr;
  int fromlen;
  int length;
  int rc, cc;
  char ThisHost[80];

  

  sp = getservbyname("echo", "tcp");
  /* get TCPClient Host information, NAME and INET ADDRESS */

  gethostname(ThisHost, MAXHOSTNAME);

  printf("----TCP/Cleint running at host NAME: %s\n", ThisHost);
  if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    fprintf(stderr, "Can't find host %s\n", ThisHost);
    exit(-1);
  }
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  printf("    (TCP/Cleint INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

  /* get TCP/Server Host information, NAME and INET ADDRESS */

  if  ( (hp = gethostbyname(argv[1])) == NULL ) {
    addr.sin_addr.s_addr = inet_addr(argv[1]);
    if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,
        sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) {
      fprintf(stderr, "Can't find host %s\n", argv[1]);
      exit(-1);
    }
  }
  printf("----TCP/Server running at host NAME: %s\n", hp->h_name);
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  printf("    (TCP/Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

  /* Construct name of socket to send to. */
  server.sin_family = hp->h_addrtype;
  /* server.sin_family = AF_INET; */

  server.sin_port = htons(atoi(argv[2]));
  /*OR    server.sin_port = sp->s_port; */

  /*   Create socket on which to send  and receive */

  sd = socket (hp->h_addrtype,SOCK_STREAM,0);
  /*OR  sd = socket (PF_INET,SOCK_STREAM,0); */

  if (sd<0) {
    perror("opening stream socket");
    exit(-1);
  }
  /* Connect to TCP/SERVER */
  if ( connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0 ) {
    close(sd);
    perror("connecting stream socket");
    exit(0);
  }
  fromlen = sizeof(from);
  if (getpeername(sd, (struct sockaddr *)&from,&fromlen)<0){
    perror("could't get peername\n");
    exit(1);
  }
  printf("Connected to TCP/Server:");
  printf("%s:%d\n", inet_ntoa(from.sin_addr),
      ntohs(from.sin_port));
  if ((hp = gethostbyaddr((void *)&from.sin_addr.s_addr,
      sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
  else
    printf("(Name is : %s)\n", hp->h_name);


  /*     get data from USER, send it SERVER,
      receive it from SERVER, display it back to USER  */
   
  for(;;) {   //menu del cliente para hacer los pedidos
int auxiliar=0;
     system("clear");
     printf("Bienvenido\n");
     printf("1) hacer pedido\n 2) Llamar mesero\n");
     scanf("%d",&auxiliar);
     if(auxiliar==1){
       enviar_pedido();
       enviar_mesa();
       enviar_plato();
       enviar_bebida();
       enviar_postre();
       printf("\ngracias por su pedido\n");
       sleep(2);
       
       }
     if(auxiliar==2){
       enviar_llamar();
       enviar_mesa();
       printf("Lo antenderemos enseguida\n");
       sleep(2);
       }
  }
  printf ("EOF... exit\n");
  close(sd);
  exit (0);
}

