
/*
NAME:      mozo
SYNOPSIS:    mozo hostid portnumber 
*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <strings.h>
#include <stdlib.h>

#define MAXHOSTNAME 80
#define BUFSIZE 1024
char buf[BUFSIZE];
char rbuf[BUFSIZE];
int   sd;




main( argc, argv )
int argc;
char *argv[];
{
  
  struct   sockaddr_in server;
  struct  hostent *hp, *gethostbyname();
  struct  servent *sp;
  struct sockaddr_in from;
  struct sockaddr_in addr;
  int fromlen;
  int length;
  int rc, cc;
  int numer_mesa;
  char ThisHost[80];
  char mesero[7]="mesero1";
  char numero[4]="1que";
  char llamar[6]="llamar";
  char entrega[7]="entrega";
  char servir[6]="servir";

  sp = getservbyname("echo", "tcp");
  /* get TCPClient Host information, NAME and INET ADDRESS */

  gethostname(ThisHost, MAXHOSTNAME);

  if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    fprintf(stderr, "Can't find host %s\n", ThisHost);
    exit(-1);
  }
  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);


  /* get TCP/Server Host information, NAME and INET ADDRESS */

  if  ( (hp = gethostbyname(argv[1])) == NULL ) {
    addr.sin_addr.s_addr = inet_addr(argv[1]);
    if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,
        sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) {
      fprintf(stderr, "Can't find host %s\n", argv[1]);
      exit(-1);
    }
  }

  bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);


  /* Construct name of socket to send to. */
  server.sin_family = hp->h_addrtype;
  /* server.sin_family = AF_INET; */

  server.sin_port = htons(atoi(argv[2]));
  /*OR    server.sin_port = sp->s_port; */

  /*   Create socket on which to send  and receive */

  sd = socket (hp->h_addrtype,SOCK_STREAM,0);
  /*OR  sd = socket (PF_INET,SOCK_STREAM,0); */

  if (sd<0) {
    perror("opening stream socket");
    exit(-1);
  }
  /* Connect to TCP/SERVER */
  if ( connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0 ) {
    close(sd);
    perror("connecting stream socket");
    exit(0);
  }
  fromlen = sizeof(from);
  if (getpeername(sd, (struct sockaddr *)&from,&fromlen)<0){
    perror("could't get peername\n");
    exit(1);
  }
  printf("Connected to TCP/Server:");
  printf("%s:%d\n", inet_ntoa(from.sin_addr),
      ntohs(from.sin_port));
  if ((hp = gethostbyaddr((void *)&from.sin_addr.s_addr,
      sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
  else


  /*     get data from USER, send it SERVER,
      receive it from SERVER, display it back to USER  */
  send(sd, mesero, 6, 0);
  send(sd, numero, 1, 0);

  for(;;) {             //sistema que se mantiene a la espera de la llegada de alguna instruccion
    
cleanup(buf);
    cleanup(rbuf);
    //printf("\n...server is waiting...\n");
    if ((cc=recv(sd, rbuf, sizeof(rbuf), 0)) < 0)
      perror("receiving stream  message");
    if (cc > 0){
      rbuf[cc]='\0'; 
     //printf("Received: %s\n", rbuf);
    }
    if(!strncmp(llamar,rbuf,6)){              // si coincide el mensaje recibido con lo que se compara avisa
      printf("Se solicita mesero\n\n ");
     }
    if(!strncmp(servir,rbuf,6)){
      printf("Platos listos para servir\n\n ");
     }


 }
  printf ("EOF... exit\n");
  close(sd);
  exit (0);
}
cleanup(buf)
char *buf;
{
  int i;
  for(i=0; i<BUFSIZE; i++) buf[i]='\0';
}
